clear all; close all; 
%% PARAMETERS
scale = 1.4;
norient = 15; ns = 3; 
expan = 14.; K = 2; 
nsketch = 100;
Lrange = 4; Orange = 1;
epsilon = .1; Upperbound = 6.; 
SHUTUP = 0.; 
%% TRAINING EXAMPLES
Folder = 'd';  % image input folder
Iname = dir([Folder '/*.jpg']);
nimage = size(Iname, 1);
Isize = zeros(nimage, 2);
fold = .5; 
for (i = 1 : nimage)
    I{i} = imresize(double(rgb2gray(imread([Folder '/' Iname(i).name]))), fold, 'nearest');
    %Ishow{i} = imread([Folder '\' Iname(i).name]); 
    Isize(i, :) = size(I{i});
end
sx = min(Isize(:, 1)); sy = min(Isize(:, 2)); 
for (i = 1 : nimage)
    I{i} = I{i}(1:sx, 1:sy); 
end   % make the sizes of the training images the same

% getting the Gabor filters for analysis 

[allfilterr, allfilteri, allsymbol] = makefilter1(scale, norient, ns, expan, K); 
[Crr, Cri, Cir, Cii] = corr1(allfilterr, allfilteri);  
[allfilteredr, allfilteredi, allfiltered] = applyfilter1(I, allfilterr, allfilteri);
half = zeros(1, norient*ns+K); 
for (i=1:norient*ns+K)
    half(i) = (size(allfilterr{1, i}, 1)-1)/2;
end

syma = zeros(sx, sy); 

sym = cell(1, ns+1); 
for (i = 1 : ns+1)
    sym{i} = zeros(sx, sy); 
end

Asym = cell(1, nimage); 
for (i = 1 : nimage)
    Asym{i} = zeros(sx, sy); 
end

Asyma = cell(1, nimage); 
for (i = 1 : nimage)
    Asyma{i} = zeros(sx, sy); 
end

Asym0 = cell(1, nimage*(ns+1));
for (i = 1 : nimage*(ns+1))
    Asym0{i} = zeros(sx, sy);  
end


mex Cmp1.c; 
Cmp1(nimage, norient*ns+K, norient, K, allfilteredr, allfilteredi, allfiltered, Crr, Cri, Cir, Cii, half, sx, sy, allfilterr(1, :), allfilteri(1, :), allsymbol(1, :), syma, sym, Asym, Asym0, Asyma, Lrange, Orange, nsketch, epsilon, Upperbound, SHUTUP);
%% save figures into eps and png folders 
outputFolder = 'deersyn';
mkdir([outputFolder 'eps']); 
mkdir([outputFolder 'png']); 

pic = syma*0.+255; showImage; 
saveas(gcf, [outputFolder 'eps/empty.eps'], 'eps');
saveas(gcf, [outputFolder 'png/empty.png'], 'png');
for (img = 1 : nimage)
    tmpIm = imresize(imread([Folder '/' Iname(img).name]), fold, 'nearest');
    pic = tmpIm(1:sx, 1:sy, :); showImage; 
    saveas(gcf, [outputFolder 'eps/input' num2str(100+img) '.eps'], 'epsc');
    saveas(gcf, [outputFolder 'png/input' num2str(100+img) '.png'], 'png');    
    pic = Asym{img}; showImage; 
    saveas(gcf, [outputFolder 'eps/syn' num2str(100+img) '.eps'], 'eps');
    saveas(gcf, [outputFolder 'png/syn' num2str(100+img) '.png'], 'png');
end
%% write the html code for reproducibility page
outputFolderOriginal = 'deer';
outputFolderSeq = 'deerseq';
outputFolderLarge = 'deerLarge';
numImage = nimage; 

heightstr = '"height=100> '; 
disp(['<IMG SRC="' outputFolderOriginal 'png/empty' '.png' heightstr]);
for (img = 1 : numImage)
 disp(['<IMG SRC="' outputFolderOriginal 'png/input' num2str(100+img) '.png' heightstr]);
end
disp('<BR>'); 

disp(['<IMG SRC="' outputFolderOriginal 'png/template' '.png' heightstr]);
for (img = 1 : numImage)
 disp(['<IMG SRC="' outputFolderOriginal 'png/sketch' num2str(100+img) '.png' heightstr]);
end
disp('<BR>'); 

disp(['<IMG SRC="' outputFolderLarge 'png/template' '.png' heightstr]);
for (img = 1 : numImage)
 disp(['<IMG SRC="' outputFolderLarge 'png/sketch' num2str(100+img) '.png' heightstr]);
end
disp('<BR>'); 

disp(['<IMG SRC="' outputFolderOriginal 'png/empty' '.png' heightstr]);
for (img = 1 : numImage)
 disp(['<IMG SRC="' outputFolder 'png/syn' num2str(100+img) '.png' heightstr]);
end
disp('<BR>'); 
%% write the LaTex code for paper 
heightstr = 'height=.6in}'; 

disp(['\psfig{figure=' outputFolderOriginal 'eps/empty' '.eps,' heightstr]); disp('&'); 
for (img = 1 : numImage)
 disp(['\psfig{figure=' outputFolderOriginal 'eps/input' num2str(100+img) '.eps,' heightstr]);
end
disp('\\ \hline'); 

disp(['\psfig{figure=' outputFolderOriginal 'eps/template' '.eps,' heightstr]); disp('&'); 
for (img = 1 : numImage)
 disp(['\psfig{figure=' outputFolderOriginal 'eps/sketch' num2str(100+img) '.eps,' heightstr]);
end
disp('\\ \hline'); 

disp(['\psfig{figure=' outputFolderLarge 'eps/template' '.eps,' heightstr]); disp('&'); 
for (img = 1 : numImage)
 disp(['\psfig{figure=' outputFolderLarge 'eps/sketch' num2str(100+img) '.eps,' heightstr]);
end
disp('\\ \hline'); 

disp(['\psfig{figure=' outputFolderOriginal 'eps/empty' '.eps,' heightstr]); disp('&'); 
for (img = 1 : numImage)
 disp(['\psfig{figure=' outputFolder 'eps/syn' num2str(100+img) '.eps,' heightstr]);
end







